--
-- Created by IntelliJ IDEA.
-- User: admin
-- Date: 8/07/2014
-- Time: 4:09 PM
-- To change this template use File | Settings | File Templates.
--

local Comergy2 = LibStub("AceAddon-3.0"):GetAddon("Comergy2")

Comergy2.options = {
    type = 'group',
    name = 'Comergy2',
    handler = Comergy2,
    get = 'Get',
    set = 'Set',
--    childGroups = 'tab',
    args = {
        general = {
            type = 'group',
            name = 'General',
            width = 'full',
            order = 1,
            args = {
                enable = {
                    type = 'toggle',
                    name = 'Enable Addon',
                    desc = 'Enable Comergy2',
                    width = 'double',
                    order = 0,
                    set = 'SetEnable',
                    get = 'GetEnable',
                },
                hideCombat = {
                    type = 'toggle',
                    name = 'Hide out of combat',
                    desc = 'Hide Comergy2 frame when out of combat',
                    order = 1,
                    set = 'SetCombat',
                },
                showNotFull = {
                    type = 'toggle',
                    name = 'Unless not stable',
                    desc = 'Show Comergy2 frame when power not static',
                    order = 2,
                },
                lock = {
                    type = 'execute',
                    name = 'Toggle Moving',
                    desc = 'Toggle Comergy2 frame moving',
                    order = 3,
                    func = 'Toggle',
                },
                reset = {
                    type = 'execute',
                    name = 'Reset Position',
                    desc = 'Reset Comergy2 frame position',
                    order = 4,
                    func = 'ResetPosition',
                },
                critSound = {
                    type = 'select',
                    name = 'Critical sound',
                    desc = 'Play sound for critical strikes',
                    dialogControl = 'LSM30_Sound', --Select your widget here
                    values = AceGUIWidgetLSMlists.sound, -- pull in your font list from LSM
                    disabled = true,
                    order = 13,
                },
                pointFrom = {
                    type = 'select',
                    name = 'Anchor From',
                    set = 'SetPosition',
                    get = 'GetPosition',
                    desc = 'Point on main frame to anchor',
                    values = {
                        CENTER = 'Center',
                        TOP = 'Top',
                        BOTTOM = 'Bottom',
                        LEFT = 'Left',
                        RIGHT = 'Right',
                        TOPLEFT = 'Top Left',
                        TOPRIGHT = 'Top Right',
                        BOTTOMLEFT = 'Bottom Left',
                        BOTTOMRIGHT = 'Bottom Right',
                    },
                    order = 5,
                },
                pointTo = {
                    type = 'select',
                    name = 'Anchor To',
                    set = 'SetPosition',
                    get = 'GetPosition',
                    desc = 'Point to anchor main frame to on screen',
                    values = {
                        CENTER = 'Center',
                        TOP = 'Top',
                        BOTTOM = 'Bottom',
                        LEFT = 'Left',
                        RIGHT = 'Right',
                        TOPLEFT = 'Top Left',
                        TOPRIGHT = 'Top Right',
                        BOTTOMLEFT = 'Bottom Left',
                        BOTTOMRIGHT = 'Bottom Right',
                    },
                    order = 6,
                },
                yOffset = {
                    type = 'range',
                    name = 'Vertical Position',
                    desc = 'Vertical position of Comergy2 frame on screen',
                    min = -floor(UIParent:GetHeight() / 2),
                    max = floor(UIParent:GetHeight() / 2),
                    bigStep = 1,
                    step = 1,
                    set = 'SetPosition',
                    get = 'GetPosition',
                    width = 'normal',
                    order = 8,
                },
                xOffset = {
                    type = 'range',
                    name = 'Horizontal Position',
                    desc = 'Horizontal position of Comergy2 frame on screen',
                    min = -floor(UIParent:GetWidth() / 2),
                    max = floor(UIParent:GetWidth() / 2),
                    bigStep = 1,
                    set = 'SetPosition',
                    get = 'GetPosition',
                    width = 'normal',
                    order = 7,
                },
                length = {
                    type = 'range',
                    name = 'Length',
                    desc = 'Length of Comergy2 frame',
                    min = 20,
                    max = 1442,
                    bigStep = 1,
                    step = 1,
                    width = 'double',
                    order = 9,
                },
                bgColor = {
                    type = 'color',
                    name = 'Background Color',
                    desc = 'Background color of Comergy2 frame',
                    set = 'SetColor',
                    get = 'GetColor',
                    hasAlpha = true,
                    order = 14,
                },
                spacing = {
                    type = 'range',
                    name = 'Spacing',
                    desc = 'Spacing between bars on Comergy2 frame',
                    min = 0,
                    max = 15,
                    bigStep = 1,
                    step = 1,
                    order = 10,
                },
                frameStrata = {
                    type = 'select',
                    name = 'Frame Strata',
                    desc = 'Strata of Comergy2 frame on screen',
                    values = {
                        BACKGROUND = 'Background',
                        LOW = 'Low',
                        MEDIUM = 'Medium',
                        HIGH = 'High',
                    },
                    order = 12,
                },
                fadingDelay = {
                    type = 'range',
                    name = 'Fading delay',
                    desc = 'Delay when fading Comergy2 frame',
                    min = 0,
                    max = 30,
                    bigStep = 0.25,
                    step = 0.25,
                    order = 11,
                },
                orientation = {
                    type = 'toggle',
                    name = 'Vertical Bars',
                    desc = 'Toggle bar orientation between horizontal and vertical',
                    disabled = true,
                    order = 16,
                },
                fillDirection = {
                    type = 'toggle',
                    name = 'Reverse bars',
                    desc = 'Toggle fill direction of bars',
                    disabled = true,
                    order = 17,
                },
                texture = {
                    type = 'select',
                    dialogControl = 'LSM30_Statusbar',
                    name = 'Texture',
                    desc = 'Texture of bars',
                    values = AceGUIWidgetLSMlists.statusbar,
                    width = 'normal',
                    set = 'SetSM3',
                    order = 15,
                },
            },
        },
        health = {
            type = 'group',
            name = 'Health',
            order = 4,
            disabled = true,
            args = {
                showPlayer = {
                    type = 'toggle',
                    name = 'Player health bar',
                    desc = 'Show a bar tracking the player\'s health',
                    order = 1,
                },
                showTarget = {
                    type = 'toggle',
                    name = 'Target health bar',
                    desc = 'Show a bar tracking the target\'s health',
                    order = 2,
                },
                playerHeight = {
                    type = 'range',
                    name = 'Player\'s health bar height',
                    desc = 'Height of the player health bar',
                    min = 1,
                    max = 50,
                    softMax = 20,
                    step = 1,
                    width = 'double',
                    order = 3,
                },
                targetHeight = {
                    type = 'range',
                    name = 'Target\'s health bar height',
                    desc = 'Height of the target health bar',
                    min = 1,
                    max = 50,
                    softMax = 20,
                    step = 1,
                    width = 'double',
                    order = 4,
                },
            },
        },
        text = {
            type = 'group',
            name = 'Text',
            order = 3,
            disabled = true,
            args = {
                fontSize = {
                    type = 'range',
                    name = 'Font size',
                    desc = 'Size of text',
                    min = 6,
                    max = 26,
                    order = 15,
                },
                textColor = {
                    type = 'color',
                    name = 'Text color',
                    desc = 'Color of text',
                    set = 'SetColor',
                    get = 'GetColor',
                    order = 16,
                },
                font = {
                    type = 'select',
                    dialogControl = 'LSM30_Font', --Select your widget here
                    name = 'Font',
                    desc = 'Font of status text on frame',
                    values = AceGUIWidgetLSMlists.font, -- pull in your font list from LSM
                },
                centerText = {
                    type = 'toggle',
                    name = 'Center Text',
                    desc = 'Center text on frame',
                    order = 18,
                },
                aboveFrame = {
                    type = 'toggle',
                    name = 'Above Frame',
                    desc = 'Display text above frame',
                    order = 19,
                },
            },
        },
    },
}



LibStub("AceConfig-3.0"):RegisterOptionsTable("Comergy2", Comergy2.options)
Comergy2.ACD = LibStub("AceConfigDialog-3.0")
Comergy2.profilesFrame = Comergy2.ACD:AddToBlizOptions("Comergy2")
--Comergy2.ACD:GetStatusTable("Comergy2").width = 800

function Comergy2:Get( info )
    return self.db.profile[info[#info]]
end

function Comergy2:Set( info, value )
    self.db.profile[info[#info]] = value
    self:RefreshConfig()
end

function Comergy2:SetCombat( info, value )
    self.db.profile[info[#info]] = value
    self.options.args.general.args.showNotFull.disabled = not value
    self:RefreshConfig()
end

function Comergy2:SetSM3( info, value )
    self.db.profile[info[#info]] = value
    self:RefreshConfig()
end

function Comergy2:SetPosition( info, value )
    self.db.profile["position"][info[#info]] = value
    --    self.frame:SetPoint("Center", self.db.profile.hPosition, self.db.profile.vPosition)
    self.Movable.UpdateMovableLayout()
    self:RefreshConfig()
end

function Comergy2:GetPosition( info )
    return self.db.profile["position"][info[#info]]
--    self.frame:SetPoint("Center", self.db.profile.hPosition, self.db.profile.vPosition)
end

function Comergy2:GetColor( info )
    local color = self.db.profile[info[#info]] or {1, 1, 1, 1}
    return color[1], color[2], color[3], color[4]
end

function Comergy2:SetColor( info, r, g, b, a )
    self.db.profile[info[#info]] = {r, g, b, a}
    self:RefreshConfig()
end

--noinspection UnusedDef
function Comergy2:GetEnable( info )
    return self:IsEnabled()
end

--noinspection UnusedDef
function Comergy2:SetEnable( info, value )
    if value then
        self:Enable()
    else
        self:Disable()
    end
end
