--
-- Created by IntelliJ IDEA.
-- User: admin
-- Date: 5/07/2014
-- Time: 10:18 PM
-- To change this template use File | Settings | File Templates.
--

local Ace = LibStub("AceAddon-3.0")
local Comergy2 = Ace:GetAddon("Comergy2")

Comergy2.prototype_primary = {

    POWER_TYPE = ENERGY,
    POWER_TYPE_TEXT = "ENERGY",
    flashTimes = -1,

    opts = {
        priority = 40,
        name = "Energy",
        bars = 1,
    },

    InitializeModule = function(self)

        self.frame = CreateFrame("Frame", "Comergy2_"..self.opts.name, Comergy2.frame)
        self.frame.priority = self.opts.priority
        self.frame:Show()

        local h = 10
        self.frame:SetHeight(h)
        self.frame:SetPoint("LEFT", Comergy2.frame, "LEFT", Comergy2.db.profile.spacing, 0)
        self.frame:SetPoint("RIGHT", Comergy2.frame, "RIGHT", -Comergy2.db.profile.spacing, 0)

        self.frame.h = h
        self.frame:SetScript("OnUpdate",
            function(...)
                self:OnUpdate(...)
            end)

        table.insert(Comergy2.frames, self.frame)
        Comergy2:Resize()

        self.bars = {}

        local bar = CreateFrame("StatusBar", "Comergy2_EnergyBar", self.frame)
        local max = UnitPowerMax("player", self.POWER_TYPE)
        bar:SetMinMaxValues(0, max > 0 and max or 100)
        bar:SetPoint("TOPLEFT")
        bar:SetPoint("BOTTOMRIGHT")
        bar:SetOrientation("HORIZONTAL")
        --    bar:SetRotatesTexture(false)

        self.bars[1] = bar

        bar.bg = bar:CreateTexture(nil, "BACKGROUND")
        bar.bg:SetTexture(0.5, 0.0, 1.0, 0.3)
        bar.bg:SetAllPoints()

        self:UpdateTextures()
        self:ColorBars()
    end,

    OnEnable = function(self)
        Comergy2:Print(self:GetName(), "enable")
    end,

    OnDisable = function(self)
        Comergy2:Print(self:GetName(), "disable")
    end,

    OnUpdate = function(self)
        local pwr = UnitPower("player", self.POWER_TYPE)
        self.bars[1]:SetValue(pwr)
    end,

    UpdateTextures = function(self)
        local tex = Comergy2.SM3:Fetch("statusbar", Comergy2.db.profile.texture)
        for i = 1, #self.bars do
            self.bars[i]:SetStatusBarTexture(tex)
        end
    end,

    ColorBars = function(self)
        local clr
        for i = 1, #self.bars do
            clr = { 0.0, 1.0, 0.0 }
            self.bars[i]:SetStatusBarColor(clr[1], clr[2], clr[3])
        end
    end,

    RefreshConfig = function()

    end,

}
